//  http://www.ne.jp/asahi/nagoya/ahomaro/builder/cpb-069.html

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Tabs, Menus;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Close1: TMenuItem;
    Reopen1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    OpenDialog1: TOpenDialog;
    PanelBack: TPanel;
    PaintBox1: TPaintBox;
    PanelBottom: TPanel;
    Label1: TLabel;
    ScrollH: TScrollBar;
    ScrollV: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollVScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollHScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Open1Click(Sender: TObject);
    procedure ScrollVChange(Sender: TObject);
    procedure ScrollHChange(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  protected
    //  hbOAhhbv֌W
    procedure CreateParams(var Params: TCreateParams);override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private
    //  h~n
    PreFormProc: TWndMethod;
    PrePanelProc: TWndMethod;
    procedure NewFormProc(var Msg: TMessage);
    procedure NewPanelProc(var Msg: TMessage);
  private
    //  #9͗p
    procedure WMGetDlgCode(var Msg: TWMGetDlgCode); message WM_GETDLGCODE;
  private
    //  XN[֌W
    FPreScrollVerticalPos: integer;
    FPreScrollHorizontallPos: integer;
    procedure AdjustScrollBarSize();
  public

  end;

var
  Form1: TForm1;

implementation

uses
    ShellApi, iEditor;

{$R *.dfm}

var
    TextEditor: TTextEditor = nil;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TForm1.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
var
    FileName: Array[0..MAX_PATH] of Char;
//    i, Count: integer;
begin
    //  hbvꂽt@C̐擾
//    Count := DragQueryFile(Msg.Drop, DWORD(-1), FileName, SizeOf(FileName));
//    for i := 0 to Count - 1 do
//    begin
//        //  ꂼ̃t@C擾
//        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
//
//    end;

    DragQueryFile(Msg.Drop, 0, FileName, SizeOf(FileName));
    TextEditor.LoadFromFile(FileName);
    ScrollV.Max := TextEditor.Lines.Count + 100;
    AdjustScrollBarSize();
    PaintBox1.Repaint;

    //  hbv
    DragFinish(Msg.Drop);
end;

//  ---------------------------------------------------------------------------
//  TABL[Ȃǂ̃L[{[hCxg𔭐邽߂̏u
procedure TForm1.WMGetDlgCode(var Msg: TWMGetDlgCode);
begin
    Msg.Result := Msg.Result or DLGC_WANTTAB;
end;

//  ---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
    PreFormProc := Self.WindowProc;
    PrePanelProc := PanelBack.WindowProc;
    Self.WindowProc := NewFormProc;
    PanelBack.WindowProc := NewPanelProc;
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];

    // eLXgGfB^GW̏
    TextEditor := TTextEditor.Create(PaintBox1);
end;
//  ---------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
    TextEditor.Free;

    PanelBack.WindowProc := PrePanelProc;
    Self.WindowProc := PreFormProc;
end;
//  ---------------------------------------------------------------------------
procedure TForm1.NewFormProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_ERASEBKGND) then Msg.Result := 0 else PreFormProc(Msg);
end;
//  ---------------------------------------------------------------------------
procedure TForm1.NewPanelProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_ERASEBKGND) then Msg.Result := 0 else PrePanelProc(Msg);
end;

//  ---------------------------------------------------------------------------
//  XN[o[
procedure TForm1.AdjustScrollBarSize();
var
    TrackHeight: Integer; { XN[o[̃gbÑTCY }
    MinHeight: Integer; { XN[{bNX̃ftHgTCY }
begin
    MinHeight := GetSystemMetrics(SM_CYVTHUMB); { ftHgTCYۑ }
    with ScrollV do
    begin
        TrackHeight := ClientHeight - 2 * GetSystemMetrics(SM_CYVSCROLL);
        PageSize := TrackHeight div (Max - Min + 1);
        if PageSize < MinHeight then PageSize := MinHeight;
    end;
end;
//  ---------------------------------------------------------------------------
//  cXN[O
procedure TForm1.ScrollVScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
    FPreScrollVerticalPos := TScrollBar(Sender).Position;
end;

//  ---------------------------------------------------------------------------
//  cXN[
procedure TForm1.ScrollVChange(Sender: TObject);
begin
    TextEditor.ScrollV(TScrollBar(Sender).Position - FPreScrollVerticalPos);
end;

//  ---------------------------------------------------------------------------
//  XN[O
procedure TForm1.ScrollHScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
    FPreScrollHorizontallPos := TScrollBar(Sender).Position;
end;

//  ---------------------------------------------------------------------------
//  XN[
procedure TForm1.ScrollHChange(Sender: TObject);
begin
    //TextEditor.ScrollH(TScrollBar(Sender).Position - FPreScrollHorizontallPos);
end;

//  ---------------------------------------------------------------------------
//  GfB^̈`
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    Pbox: TPaintBox;
    cx, cy: integer;
begin
    Pbox := TPaintBox(Sender);

    //  eLXgGfB^`悷
    TextEditor.Paint(Pbox.Canvas, cx, cy);

    //  IME̓̓EBhEʒueLXgGfB^̃J[\ɍ킹
    SetImeCompositionWindow(Pbox.Canvas.Font, cx, cy);


    //  Xe[^Xo[XV
    StatusBar1.Panels[0].Text := Format('Row:%d Col:%d', [
        TextEditor.Cursor.Row + 1,
        TextEditor.Cursor.Col
    ])
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
    TextEditor.KeyPress(Key);
    ScrollV.Max := TextEditor.Lines.Count + 100;
    AdjustScrollBarSize();
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    TextEditor.KeyDown(Key, Shift);
    ScrollV.Max := TextEditor.Lines.Count + 100;
    AdjustScrollBarSize();
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
    if OpenDialog1.Execute then
    begin
        TextEditor.LoadFromFile(OpenDialog1.FileName);
        AdjustScrollBarSize();
        ScrollV.Max := TextEditor.Lines.Count + 100;
        PaintBox1.Repaint;
    end;
end;

//  http://tomizawa-web.hp.infoseek.co.jp/property/wheelDelta.htm
procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
    TextEditor.ScrollV(- WheelDelta div 120);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    TextEditor.SetCursorPos(Point(X, Y));
end;

end.

