(*
	//==========================================
	// eLXg֘A

	// eLXgCt@C
	AnsiString FileName;

	//==========================================
	// `֘A

	// \p^[ƁC̒̕s\p^[
	TList *Highlights, *HighlightsMulti;

	// P\镶̃Zbg
	AnsiString WordLetters;

	// ftHg̕\CftHg̃tHg
	TAttribute* BasicAttribute;
	TFont* BasicFont;

	//==========================================
	// I֘A

	// I͈͂̕\
	TAttribute* SelAttribute;

public:
	// {ݒCL[ݒC\ݒt@C̓ǂݍ
	void LoadIniFile(AnsiString file_name);
	void LoadHighlightFile(AnsiString file_name);

	//==========================================
	// 擾

	// t@CԂ
	AnsiString GetFileName() { return FileName; }

	// tHgԂ
	TFont* GetBasicFont() { return BasicFont; }
*)

unit iEditor;

interface

uses
    Windows, SysUtils, Classes, Graphics, Controls, Contnrs;

type
//=============================================================================
//  UTILITY
//=============================================================================

    //-----------------------------
    //  J[\ʒu
    TCursorPos = record
        Row: integer;   //  sԍ(0ȏ)
        Col: integer;   //  (1ȏ)
    end;

    //-----------------------------
    //  L[oChݒ\Ȋ֐
    TEditorCommand = procedure(const Shift: TShiftState) of object;

    //-----------------------------
    //  s錾
    TTextEditor = class;

//=============================================================================
//  AhD^hD̂߂̃NX
//=============================================================================

    //-----------------------------
    TCommand = class
    private
        procedure Execute(Editor: TTextEditor); virtual; abstract;
    end;

    //-----------------------------
    //  }\NX
    TInsertCommand = class(TCommand)
    private
        FPos: TCursorPos;
        FText: string;
    public
        constructor Create(const DidPos: TCursorPos; const Text: string);
        //  eLXg̑}ʒuɑ}}
        procedure Execute(Editor: TTextEditor); override;
    end;

    //-----------------------------
    //  폜\NXF
    TDeleteCommand = class(TCommand)
    private
        FStartPos: TCursorPos;
        FEndPos: TCursorPos;
    public
        constructor Create(const StartPos, EndPos: TCursorPos);
        //  eLXg̊JnʒuIʒu܂ł폜
        procedure Execute(Editor: TTextEditor); override;
    end;

//=============================================================================
//  TTextEditorNX : eLXgGfB^̖{
//=============================================================================

    TTextEditor = class

    //-----------------------------
    //  eLXg
    private
        FLines: TStrings;
        FStrBuf: TStrings;

    //-----------------------------
    //  J[\
    private
        //  J[\sE
        FCursor: TCursorPos;
        //  ȑOJ[\i㉺XN[pj
        FPrevCursorColumn: integer;
        // \Ăԏ̍s
        FTopLine: integer;

        // J[\1ǑC1̌Ԃi2oCglj
        function GetPrevColumn(): integer;
        function GetNextColumn(): integer;

        //  ݃J[\L^E(㉺XN[)
        procedure SetPrevCursorColumn();
        procedure SetCursorColumn();

    //-----------------------------
    //  I𑀍
    private
        //  I͈
        FSelStart: TCursorPos;
        FSelEnd: TCursorPos;
        //  I𑀍Jn
        FSelOpeStart: TCursorPos;
        //  I𑀍쒆
        FSelecting: Boolean;

        //  I𑀍Jn
        procedure SelStart();
        //  I𑀍I
        procedure SelEnd();
        //  I͈͍XV
        procedure SetSelPos();

    //-----------------------------
    //  AhD^hD֘A
    private
        //  AhD^hDp̃X^bN
        FUndoStack: TObjectStack;
        FRedoStack: TObjectStack;

        //  true Ȃ AhDX^bNɑǉAhDX^bNS
        //  ʏҏWtrueŁCAhD^hD̂false
        FClearRedoStack: Boolean;

        //  AhDpo^
        procedure UndoPush(Command: TCommand);

    public
        procedure Undo(const Shift: TShiftState);
        procedure Redo(const Shift: TShiftState);

    //-----------------------------
    //  `
    private
        //  _uobt@
        FDBuffer: TBitmap;
        //  Canvas̎
        FControl: TControl;

    //-----------------------------
    public
        //  `
        procedure Paint(Canvas: TCanvas; var CursorX, CursorY: integer);
    //-----------------------------
    public
        //  RXgN^
        constructor Create(Control: TControl);
        //  fXgN^
        destructor Destroy(); override;
    private
        //  J[\NA
        procedure ClearCursor();
        //  L[oCht@CǍ
        procedure LoadKeyBindFile(const Path: string);
        //  R}h֐|C^ɕϊݒ肷
        procedure SetCommand(const CommandName: string; Command: TEditorCommand);

    //-----------------------------
    //  {
    private
        //  ͂ꂽ2oCg1
        FLeadByte: Char;

        //  1J[\ʒuɑ}
        procedure InsertChar(const c: Char);
        //  1O
        procedure BackSpace(const Shift: TShiftState);
        //  1
        procedure DeleteChar(const Shift: TShiftState);

    public
        //  KeyDown͓L[CKeyPress͈ʃL[iIME܂ށj
        procedure KeyDown(const Key: WORD; const Shift: TShiftState);
        procedure KeyPress(const Key: Char);

        //  ǂݍ
        procedure LoadFromFile(const FileName: string);
        //  ۑ
        procedure SaveToFile(const FileName: string);

    //-----------------------------
    //  ҏW
    private
        procedure DeleteText(const StartPos, EndPos: TCursorPos);
        function CopyText(const StartPos, EndPos: TCursorPos): string;
        procedure InsertText(const DoPos: TCursorPos; const Text: string);

    //-----------------------------
    //  R}h(J[\ړ)
    private
        //  R}h̃e[u
        FCommand: array[Char] of TEditorCommand;

        procedure PrevLine(const Shift: TShiftState);
        procedure NextLine(const Shift: TShiftState);
        procedure PrevChar(const Shift: TShiftState);
        procedure NextChar(const Shift: TShiftState);
        procedure PrevPage(const Shift: TShiftState);
        procedure NextPage(const Shift: TShiftState);
        procedure LineHome(const Shift: TShiftState);
        procedure LineEnd(const Shift: TShiftState);

    //-----------------------------
    //  R}h(Nbv{[h)
        procedure SelCut(const Shift: TShiftState);
        procedure SelCopy(const Shift: TShiftState);
        procedure SelPaste(const Shift: TShiftState);
        procedure SelDelete(const Shift: TShiftState);

    //-----------------------------
    public
        //  cXN[
        procedure ScrollV(const Value: integer);
        //  }EXɂJ[\ړ
        procedure SetCursorPos(const CursorPoint: TPoint);

    //-----------------------------
    //  擾
    public
        //  \sԂ
        function GetDispLineCount(): integer;

    //-----------------------------
    public
        property Lines: TStrings read FLines;
        property Cursor: TCursorPos read FCursor;
    end;

var
    // ^u1ɑ锼p󔒂̐
    FSpacesForTab: integer = 4;

    // XN[̍ۂɏ㉺Ɏcs
    FScrollMargin: integer = 1;

    //  GfB^̔wiF
    FBackColor: TColor = clWhite;

    //  GfB^̃tHg̐F
    FFontColor: TColor = clBlack;

    //  J[\̐F
    FCursorColor: TColor = clBlack;

    //  ݍs̉̐F
    FCurrentLineColor: TColor = clSilver;

    //  I͈͂̔wiF
    FSelBackColor: TColor = clHighlight;

    //  I͈͂̃tHg̐F
    FSelFontColor: TColor = clHighlightText;

    //  1s̏㉺}[W(Ɖɓ)
    FLineMargin: integer = 4;

    //  }[W
//    FLeftMargin: integer = 40;

    //  }[W
//    FTopMargin: integer = 20;

    //  XN[1XN[s
    FScrollRatio: integer = 5;

implementation

uses
    Clipbrd, StrUtils;

//=============================================================================
//  UTILITY
//=============================================================================

//-----------------------------------------------------------------------------
//  ^u𔼊p󔒂ɕϊ(s̒̃^u𔼊p󔒂ɕϊĕԂ)
//  ^u1 -> p SpacesForTab 
function TabsToSpaces(const s: string): string;
begin
    Result := StringReplace(s, #9, StringOfChar(' ', FSpacesForTab), [rfReplaceAll]);
end;

//-----------------------------------------------------------------------------
//  L[L[R[hɕϊizL[R[hCASCIIR[hj
function KeyNameToCode(const Name: string): integer;
var
    s: string;
begin
    s := AnsiUpperCase(Name);

	//  1ȂΉpƌȂASCIIR[hɕϊ
    if (Length(s) = 1) then Result := Ord(s[1])

	//  L[zL[R[hɕϊ
    else if (s = 'UP')        then Result := VK_UP
    else if (s = 'DOWN')      then Result := VK_DOWN
    else if (s = 'LEFT')      then Result := VK_LEFT
    else if (s = 'RIGHT')     then Result := VK_RIGHT
    else if (s = 'BACKSPACE') then Result := VK_BACK
    else if (s = 'ESC')       then Result := VK_ESCAPE
    else if (s = 'ENTER')     then Result := VK_RETURN
    else if (s = 'PAGEUP')    then Result := VK_PRIOR
    else if (s = 'PAGEDOWN')  then Result := VK_NEXT
    else Result := 0;
end;

//=============================================================================
//  AhD^hD̂߂̃NX
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TInsertCommand.Create(const DidPos: TCursorPos; const Text: string);
begin
    FPos := DidPos;
    FText := Text;
end;

//-----------------------------------------------------------------------------
//  eLXg̑}ʒuɑ}}
procedure TInsertCommand.Execute(Editor: TTextEditor);
begin
    Editor.InsertText(FPos, FText);
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TDeleteCommand.Create(const StartPos, EndPos: TCursorPos);
begin
    FStartPos := StartPos;
    FEndPos := EndPos;
end;

//-----------------------------------------------------------------------------
//  eLXg̊JnʒuIʒu܂ł폜
procedure TDeleteCommand.Execute(Editor: TTextEditor);
begin
    Editor.DeleteText(FStartPos, FEndPos);
end;

//=============================================================================
//  TTextEditorNX : eLXgGfB^̖{
//=============================================================================

//-----------------------------------------------------------------------------
//  J[\NA
procedure TTextEditor.ClearCursor();
begin
    FLines.Clear;
    FLines.Add('');

    //  J[\ʒȕ
    FCursor.Row := 0;
    FCursor.Col := 1;
    FPrevCursorColumn := 1;
    FTopLine := 0;

    //  I͈͂Ɋւ鏉
    FSelecting := False;
    FSelStart.Row := 0;
    FSelStart.Col := 1;
    FSelEnd := FSelStart;

    //  AhD/hDobt@NA
    while FUndoStack.AtLeast(1) do FUndoStack.Pop.Free;
    while FRedoStack.AtLeast(1) do FRedoStack.Pop.Free;

    FLeadByte := #0;
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TTextEditor.Create(Control: TControl);
begin
    //  eLXgpIuWFNg
    FLines := TStringList.Create;
    FStrBuf := TStringList.Create;

    //  AhD/hD֘A
    FUndoStack := TObjectStack.Create;
    FRedoStack := TObjectStack.Create;
    FClearRedoStack := True;

    //  낢돉
    ClearCursor();

    //  `֘A
    FDBuffer := TBitmap.Create;
    FControl := Control;

	//  R}h蓖ĕ\
    FillChar(FCommand, SizeOf(FCommand), 0);

    //  ƃL[N
    LoadKeyBindFile(ChangeFileExt(ParamStr(0), 'kbd'));
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TTextEditor.Destroy();
begin
    FLines.Free;
    FStrBuf.Free;

    while FUndoStack.AtLeast(1) do FUndoStack.Pop.Free;
    while FRedoStack.AtLeast(1) do FRedoStack.Pop.Free;
    FUndoStack.Free;
    FRedoStack.Free;

    inherited;
end;

//=============================================================================
//  CURSOR
//=============================================================================

//-----------------------------------------------------------------------------
// J[\1̌(2oCg2oCgڂ̏ꍇɂ́C1̌)
function TTextEditor.GetPrevColumn(): integer;
var
    Line: string;
begin
    Line := Lines[FCursor.Row];
    Result := FCursor.Col - 1;
    if (Result > 0) and (ByteType(Line, Result) = mbTrailByte) then
    begin
        Dec(Result);
    end;
end;

//-----------------------------------------------------------------------------
//  J[\1Ě(2oCg2oCgڂ̏ꍇɂ́C1Ě)
function TTextEditor.GetNextColumn(): integer;
var
    Line: string;
begin
    Line := Lines[FCursor.Row];
    Result := FCursor.Col + 1;
    if (Result <= Length(Line)) and (ByteType(Line, Result) = mbTrailByte) then
    begin
        Inc(Result);
    end;
end;

//-----------------------------------------------------------------------------
//  ݃J[\錅L^(L^̂̓^u𔼊p󔒂ɓWJ̌)
procedure TTextEditor.SetPrevCursorColumn();
var
    Line: string;
begin
	Line := TabsToSpaces(Copy(FLines[FCursor.Row], 1, FCursor.Col - 1));
    FPrevCursorColumn := 1 + Length(Line);

    //  I𓮍쒆̏ꍇCI͈͂XV
    SetSelPos();
end;

//-----------------------------------------------------------------------------
//  ȑOL^J[\̌Č
procedure TTextEditor.SetCursorColumn();
var
    Line: string;
    i, l: integer;
begin
    Line := Lines[FCursor.Row];

    //  PrevCursorColumn̓^u𔼊p󔒂ɓWJ̒lȂ̂ŁC
    //  J[\s̃^uWJCׂ
    //  CursorColumnɂ͓WJȎΉ錅ݒ肷
    l := 0;
    i := 1;
    while (i <= Length(Line)) do
    begin
        if (Line[i] = #9) then Inc(l, FSpacesForTab) else Inc(l);
        if (FPrevCursorColumn <= l) then break;
        Inc(i);
    end;

	// sEɂȂC2oCg2oCgڂƂ̏
	if (i <= Length(Line)) and (ByteType(Line, i) = mbTrailByte) then
        FCursor.Col := i - 1
	else
        FCursor.Col := i
    ;

    //  I𓮍쒆̏ꍇCI͈͂XV
    SetSelPos();
end;

//=============================================================================
//  R}hEJ[\ړn
//=============================================================================

//-----------------------------------------------------------------------------
//  L[oCht@CǍ
procedure TTextEditor.LoadKeyBindFile(const Path: string);
begin
    //t@CǍ
    //  

	//  R}h蓖ĕ\
    FillChar(FCommand, SizeOf(FCommand), 0);

    //  
    FCommand[Chr(VK_LEFT)] := PrevChar;
    FCommand[Chr(VK_UP)]   := PrevLine;
    FCommand[Chr(VK_RIGHT)] := NextChar;
    FCommand[Chr(VK_DOWN)] := NextLine;

    FCommand[Chr(VK_BACK)] := BackSpace;
    FCommand[Chr(VK_DELETE)] := DeleteChar;

    FCommand[Chr(VK_PRIOR)] := PrevPage;
    FCommand[Chr(VK_NEXT)] := NextPage;

    FCommand[Chr(VK_HOME)] := LineHome;
    FCommand[Chr(VK_END)] := LineEnd;

    FCommand['C'] := SelCopy;
    FCommand['V'] := SelPaste;
    FCommand['X'] := SelCut;

    FCommand['Y'] := Redo;
    FCommand['Z'] := Undo;
end;

//-----------------------------------------------------------------------------
//  R}h֐|C^ɕϊݒ肷
procedure TTextEditor.SetCommand(const CommandName: string; Command: TEditorCommand);
var
    s: string;
begin
    s := AnsiUpperCase(CommandName);

    if (s = 'PREVCHAR') then        Command := PrevChar
    else if (s = 'PREVLINE') then   Command := PrevLine
    else if (s = 'NEXTCHAR') then   Command := NextChar
    else if (s = 'NEXTLINE') then   Command := NextLine
    else if (s = 'BACKSPACE') then  Command := BackSpace
    else if (s = 'DELETE') then     Command := DeleteChar
    else if (s = 'PREVPAGE') then   Command := PrevPage
    else if (s = 'NEXTPAGE') then   Command := NextPage
    else if (s = 'HOME') then       Command := LineHome
    else if (s = 'END') then        Command := LineEnd
    else if (s = 'SELCUT') then     Command := SelCut
    else if (s = 'SELCOPY') then    Command := SelCopy
    else if (s = 'SELPASTE') then   Command := SelPaste
    else if (s = 'UNDO') then       Command := Undo
    else if (s = 'REDO') then       Command := Redo
    else Command := nil;
end;

//-----------------------------------------------------------------------------
//  KeyDownCxgiJ[\Ȃǂ̓L[j
procedure TTextEditor.KeyDown(const Key: WORD; const Shift: TShiftState);
var
    Command: TEditorCommand;
begin
    Command := FCommand[Chr(Key)];

    if Assigned(Command) then
    begin
        if (ssShift in Shift) then
        begin
            SelStart();
            Command(Shift);
            SetSelPos();
        end
        else
        begin
            Command(Shift);
            SelEnd();
        end;
    end;
//    else SelEnd();
end;

//-----------------------------------------------------------------------------
//  J[\1sɈړ
procedure TTextEditor.PrevLine(const Shift: TShiftState);
begin
    if (FCursor.Row > 0) then
    begin
        Dec(FCursor.Row);
        SetCursorColumn();
        FControl.Invalidate();
    end;
end;

//-----------------------------------------------------------------------------
//  J[\1sɈړ
procedure TTextEditor.NextLine(const Shift: TShiftState);
begin
    if (FCursor.Row < FLines.Count - 1) then
    begin
        Inc(FCursor.Row);
        SetCursorColumn();
        FControl.Invalidate();
    end;
end;

//-----------------------------------------------------------------------------
//  J[\1Ɉړ
procedure TTextEditor.PrevChar(const Shift: TShiftState);
var
    Col: integer;
begin
    Col := GetPrevColumn();

    //  sōɈړłꍇ
    if (Col > 0) then
    begin
        FCursor.Col := Col;
    end
    //  O̍sɈړꍇ
    else if (FCursor.Row > 0) then
    begin
        Dec(FCursor.Row);
        FCursor.Col := Length(FLines[FCursor.Row]) + 1;
    end;

    SetPrevCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  J[\1EɈړ
procedure TTextEditor.NextChar(const Shift: TShiftState);
begin
    //  ̍sɈړꍇ
    if (FCursor.Col > Length(FLines[FCursor.Row])) then
    begin
        if (FCursor.Row < FLines.Count - 1) then
        begin
            Inc(FCursor.Row);
            FCursor.Col := 1;
        end;
    end
    //  sŉEɈړłꍇ
    else
    begin
        FCursor.Col := GetNextColumn();
    end;
    SetPrevCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  J[\1y[WOɈړ
//  P1y[WOɈړāCeLXg̐擪OɂȂC
procedure TTextEditor.PrevPage(const Shift: TShiftState);
begin
    Dec(FCursor.Row, GetDispLineCount());
    if (FCursor.Row < 0) then FCursor.Row := 0;
    SetCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  J[\1y[WɈړ
//  P1y[WɈړāCeLXg̖ɂȂC
procedure TTextEditor.NextPage(const Shift: TShiftState);
begin
    Inc(FCursor.Row, GetDispLineCount());
    if (FCursor.Row >= FLines.Count) then FCursor.Row := FLines.Count - 1;
    SetCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  J[\ݍs1ڂ
procedure TTextEditor.LineHome(const Shift: TShiftState);
begin
    //  CTRLtȂ1sڂɈړ
    if (ssCtrl in Shift) then FCursor.Row := 0;
    //  sɈړ
    FCursor.Col := 1;

    SetPrevCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  J[\ݍs̖
procedure TTextEditor.LineEnd(const Shift: TShiftState);
begin
    //  CTRLtȂŌ̍sɈړ
    if (ssCtrl in Shift) then FCursor.Row := FLines.Count - 1;
    //  sɈړ
    FCursor.Col := Length(FLines[FCursor.Row]) + 1;

    SetPrevCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  cXN[
procedure TTextEditor.ScrollV(const Value: integer);
begin
    SelEnd();
    Inc(FCursor.Row, Value * FScrollRatio);
    if (FCursor.Row < 0) then FCursor.Row := 0
    else if (FCursor.Row >= FLines.Count) then FCursor.Row := FLines.Count - 1;
    SetCursorColumn();
    FControl.Invalidate();
end;

//-----------------------------------------------------------------------------
//  }EXɂJ[\ړ
procedure TTextEditor.SetCursorPos(const CursorPoint: TPoint);
var
    h: integer;
begin
    SelEnd();
    //  1s̍
    h := FDBuffer.Canvas.TextHeight('Wg') + FLineMargin * 2;
    //  \s擪猩
    FCursor.Row := (CursorPoint.Y div h) + FTopLine;
    if (FCursor.Row < 0) then FCursor.Row := 0
    else if (FCursor.Row >= FLines.Count) then FCursor.Row := FLines.Count - 1;
    SetCursorColumn();
    FControl.Invalidate();
end;

//=============================================================================
//  R}hENbv{[hn
//=============================================================================

//-----------------------------------------------------------------------------
//  ؂FI͈͂Nbv{[hɃRs[C폜
//  Iꂽ1̂Ƃ͑I𓮍̏Î
procedure TTextEditor.SelCut(const Shift: TShiftState);
var
    SelText: string;
begin
    SelText := CopyText(FSelStart, FSelEnd);
    if (SelText <> '') then Clipboard.AsText := SelText;
    SelDelete(Shift);
end;

//-----------------------------------------------------------------------------
//  Rs[FI͈͂Nbv{[hɃRs[
//  Iꂽ1̂Ƃ͑I𓮍̏Î
procedure TTextEditor.SelCopy(const Shift: TShiftState);
var
    SelText: string;
begin
    SelText := CopyText(FSelStart, FSelEnd);
    if (SelText <> '') then Clipboard.AsText := SelText;
    SelEnd();
end;

//-----------------------------------------------------------------------------
//  \tFJ[\ʒuɃNbv{[h̓e}
//  I𒆂ȂΑI͈͂폜Ă}
procedure TTextEditor.SelPaste(const Shift: TShiftState);
var
    ClipText: string;
    CurPos: TCursorPos;
begin
    //  Nbv{[h當擾
    ClipText := ClipBoard.AsText;
    if (ClipText <> '') then
    begin
        //  I𒆂̏ꍇCI͈͂폜
        SelDelete(Shift);

        //  ̑}ƃJ[\ʒu̍XV
        CurPos := FCursor;
        InsertText(CurPos, ClipText);
    end;
end;

//-----------------------------------------------------------------------------
//  폜FI͈͂폜CJ[\I͈͂̐擪ɖ߂
//  Iꂽ1̂Ƃ͑I𓮍̏Îݍs
procedure TTextEditor.SelDelete(const Shift: TShiftState);
begin
    DeleteText(FSelStart, FSelEnd);
    SelEnd();
end;

//=============================================================================
//  I͈͂̑
//=============================================================================

//-----------------------------------------------------------------------------
//  ͈͑I[h̊Jn
procedure TTextEditor.SelStart();
begin
    if (not FSelecting) then
    begin
        FSelecting := True;         //  I𒆃tO
        FSelOpeStart := FCursor;    //  JnʒuL^
        FSelStart := FCursor;       //  IJnʒu
        FSelEnd := FCursor;         //  IIʒu(̎_ł͑I͈͂͋)
        FControl.Invalidate();
    end;
end;

//-----------------------------------------------------------------------------
//  ͈͑I[h̏IF
procedure TTextEditor.SelEnd();
begin
    if (FSelecting) then
    begin
        FSelecting := False;
        FSelStart := FCursor;
        FSelEnd := FCursor;
        FControl.Invalidate();
    end;
end;

//-----------------------------------------------------------------------------
//  ͈͑I[hs̏ꍇCI͈͂XV
procedure TTextEditor.SetSelPos();
begin
    if FSelecting then
    begin
        //  J[\I[hJnʒuɂ
        if (FSelOpeStart.Row < FCursor.Row)
        or ((FSelOpeStart.Row = FCursor.Row) and (FSelOpeStart.Col <= FCursor.Col)) then
        begin
            //  I[hJnʒuJ[\ʒu܂łI
            FSelStart := FSelOpeStart;
            FSelEnd := FCursor;
        end

        //  J[\I[hJnʒuOɂƂF
        else
        begin
            //  J[\ʒuI[hJnʒu܂łI
            FSelStart := FCursor;
            FSelEnd := FSelOpeStart;
        end;
    end;
end;

//=============================================================================
//  {
//=============================================================================

//-----------------------------------------------------------------------------
//  1}
procedure TTextEditor.InsertChar(const c: Char);
var
    CurPos: TCursorPos;
begin
    //  I𒆂̏ꍇCI͈͂폜
    SelDelete([]);

    //  ̑}ƁCJ[\ʒu̍XV

    //  2oCg1ڂ͂ĂꍇC܂Ƃ߂đ}
    if (FLeadByte <> #0) then
    begin
        CurPos := FCursor;
        InsertText(CurPos, FLeadByte + c);
        FLeadByte := #0;
    end
    //  1oCgC2oCg1oCgڂ
    else
    begin
        if (ByteType(c, 1) = mbLeadByte) then
        begin
            FLeadByte := c;
        end
        else
        begin
			//?if (c=='\r') c='\n';
            CurPos := FCursor;
            InsertText(CurPos, c);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  obNXy[Xi1j
procedure TTextEditor.BackSpace(const Shift: TShiftState);
var
    Col: integer;
    S, E: TCursorPos;
begin
    Col := GetPrevColumn();

    //  I𒆂̏ꍇ͑I͈͂폜
    if FSelecting then SelDelete([])

    //  I𒆂ł͂Ȃꍇ
    else
    begin
        //  J[\s̒1ςޏꍇ
        if (Col > 0) then
        begin
            S := FCursor;
            E := FCursor;
            S.Col := Col;
            DeleteText(S, E);
        end
        //  J[\s̒ł͍ς܂CO̍sɉeyԏꍇ
        else if (FCursor.Row > 0) then
        begin
            Col := Length(FLines[FCursor.Row - 1]) + 1;
            S := FCursor;
            E := FCursor;
            Dec(S.Row);
            S.Col := Col;
            E.Col := 1;
            DeleteText(S, E);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  DELETEL[ɂ1(폜)
procedure TTextEditor.DeleteChar(const Shift: TShiftState);
var
    Line: string;
    S, E: TCursorPos;
begin
    //  I𒆂̏ꍇ͑I͈͂폜
    if FSelecting then SelDelete([])

    //  I𒆂ł͂Ȃꍇ
    else
    begin
        Line := FLines[FCursor.Row];

        //  J[\s̒1ςޏꍇ
        if (FCursor.Col <= Length(Line)) then
        begin
            S := FCursor;
            E := FCursor;
            E.Col := GetNextColumn();
            DeleteText(S, E);
        end
        //  J[\s̒ł͍ς܂C̍sɉeyԏꍇ
        else if (FCursor.Row < FLines.Count - 1) then
        begin
            S := FCursor;
            E := FCursor;
            Inc(E.Row);
            E.Col := 1;
            DeleteText(S, E);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  KeyPressCxgiʃL[BIMEoR̓͂܂ށj
//  eLXgɑ}\ȕ͂ꂽC}s
procedure TTextEditor.KeyPress(const Key: Char);
var
    c: integer;
begin
    c := Ord(Key);
    if (c >= $20) or (c = VK_TAB) or (c = VK_RETURN) then
    begin
        //  
        InsertChar(Key);
        //  I𑀍쒆f
        SelEnd();
    end;
end;

//-----------------------------------------------------------------------------
//  ǂݍ
procedure TTextEditor.LoadFromFile(const FileName: string);
begin
    ClearCursor();
    FLines.LoadFromFile(FileName);
end;

//-----------------------------------------------------------------------------
//  ۑ
procedure TTextEditor.SaveToFile(const FileName: string);
begin
    FLines.SaveToFile(FileName);
end;

//=============================================================================
//  ҏW
//=============================================================================

//-----------------------------------------------------------------------------
//  }FTextɉs܂܂ĂꍇCsɓWJ
//  }͈̖͂ɃJ[\ړ
procedure TTextEditor.InsertText(const DoPos: TCursorPos; const Text: string);
var
    Line, Left, Rite: string;
    i: integer;
begin
    //  ͈̓`FbNȂ
    if (DoPos.Row < 0) then Exit;
    if (FLines.Count <= DoPos.Row) then Exit;
    if (DoPos.Col < 1) then Exit;
    if (Length(FLines[DoPos.Row]) + 1 < DoPos.Col) then Exit;
    if (Text = '') then Exit;

	//  sɓWJ(̉sȂ悤C_~[̕t)
    FStrBuf.Text := Text;
    if AnsiEndsText(#10, Text) or AnsiEndsText(#13, Text) then
        FStrBuf.Add('');

    //  }ʒu̍̕lɁCE̕rɑ
    Line := FLines[DoPos.Row];
    Left := Copy(Line, 1, DoPos.Col - 1);
    Rite := Copy(Line, DoPos.Col, Length(Line) + 1 - DoPos.Col);

    //  1s̏ꍇ
    if (FStrBuf.Count = 1) then
    begin
        FLines[DoPos.Row] := Left + FStrBuf[0] + Rite;
        FCursor.Row := DoPos.Row;
        FCursor.Col := 1 + Length(Left) + Length(FStrBuf[0]);
    end
    //  2sȏ̏ꍇ
    else
    begin
        //  1sڂJ[\sɘA
        FLines[DoPos.Row] := Left + FStrBuf[0];

        //  2sڈȍ~}(͒ǉ)
        if (DoPos.Row < FLines.Count - 1) then
        begin
            for i := 1 to FStrBuf.Count - 1 do
            begin
                if (i < FStrBuf.Count - 2) then
                    FLines.Insert(DoPos.Row + i, FStrBuf[i])
                else
                    //  Ō̍sƃJ[\ʒủEcA
                    FLines.Insert(DoPos.Row + i, FStrBuf[i] + Rite);
                ;
            end;
        end
        else
        begin
            for i := 1 to FStrBuf.Count - 1 do
            begin
                if (i < FStrBuf.Count - 2) then
                    FLines.Add(FStrBuf[i])
                else
                    //  Ō̍sƃJ[\ʒủEcA
                    FLines.Add(FStrBuf[i] + Rite);
                ;
            end;
        end;

        FCursor.Row := DoPos.Row + FStrBuf.Count - 1;
        FCursor.Col := 1 + Length(FStrBuf[FStrBuf.Count - 1]);
    end;

    //  J[\̋L^ƍĕ`
    SetPrevCursorColumn();
    FControl.Invalidate();

    //  AhDp̏L^
    UndoPush(TDeleteCommand.Create(DoPos, FCursor));

    FStrBuf.Clear();
end;

//-----------------------------------------------------------------------------
//  폜Fw肳ꂽ͈͂̕is\j
//  폜͈͂̐擪ɃJ[\ړ
procedure TTextEditor.DeleteText(const StartPos, EndPos: TCursorPos);
var
    Line, DelText: string;
    Line1, Line2: string;
    i: integer;
begin
    //  ͈̓`FbNȂ
    if (StartPos.Row < 0) then Exit;
    if (FLines.Count <= StartPos.Row) then Exit;
    if (EndPos.Row < 0) then Exit;
    if (FLines.Count <= EndPos.Row) then Exit;

    if (StartPos.Col < 1) then Exit;
    if (Length(FLines[StartPos.Row]) + 1 < StartPos.Col) then Exit;
    if (EndPos.Col < 1) then Exit;
    if (Length(FLines[EndPos.Row]) + 1 < EndPos.Col) then Exit;

    if (EndPos.Row < StartPos.Row) then Exit;
    if (EndPos.Row = StartPos.Row) and (EndPos.Col <= StartPos.Col) then Exit;

    //  JnƏIs̏ꍇ
    if (StartPos.Row = EndPos.Row) then
    begin
        Line := FLines[StartPos.Row];

        //  폜L^
        DelText := Copy(Line, StartPos.Col, EndPos.Col - StartPos.Col);
        //  폜
        Delete(Line, StartPos.Col, EndPos.Col - StartPos.Col);

        FLines[StartPos.Row] := Line;
    end
    //  JnƏIႤs̏ꍇ
    else
    begin
        FStrBuf.Clear();

        //  Jns̏
        Line1 := FLines[StartPos.Row];
        FStrBuf.Add(Copy(Line1, StartPos.Col, Length(Line1) + 1 - StartPos.Col));
        Line1 := Copy(Line1, 1, StartPos.Col - 1);

        //  Is̏
        Line2 := FLines[EndPos.Row];
        DelText := Copy(Line2, 1, EndPos.Col - 1);
        Line2 := Copy(Line2, EndPos.Col, Length(Line2) + 1 - EndPos.Col);

        //  JnsƏIs
        FLines[StartPos.Row] := Line1 + Line2;

        //  svȍs폜
        for i := 0 to EndPos.Row - StartPos.Row - 2 do
        begin
            FStrBuf.Add(FLines[StartPos.Row + 1]);
            FLines.Delete(StartPos.Row + 1);
        end;
        FLines.Delete(StartPos.Row + 1);

        //  ŏIIȍ폜쐬
        DelText := FStrBuf.Text + DelText;

        FStrBuf.Clear();
	end;

    //  J[\̈ړCJ[\̋L^Cĕ`
    FCursor := StartPos;
    SetPrevCursorColumn();
    FControl.Invalidate();

    //  AhDp̏L^
    UndoPush(TInsertCommand.Create(FCursor, DelText));
end;

//-----------------------------------------------------------------------------
//  Rs[Fw肳ꂽ͈͂̕ԂB
//  s̏ꍇCsƍsƂ̊ԂɉsB
//  Iꂽ1̏ꍇC󕶎Ԃ
function TTextEditor.CopyText(const StartPos, EndPos: TCursorPos): string;
var
    i: integer;
begin
    Result := '';

    //  ͈̓`FbNȂ
    if (StartPos.Row < 0) then Exit;
    if (FLines.Count <= StartPos.Row) then Exit;
    if (EndPos.Row < 0) then Exit;
    if (FLines.Count <= EndPos.Row) then Exit;

    if (StartPos.Col < 1) then Exit;
    if (Length(FLines[StartPos.Row]) + 1 < StartPos.Col) then Exit;
    if (EndPos.Col < 1) then Exit;
    if (Length(FLines[EndPos.Row]) + 1 < EndPos.Col) then Exit;

    if (EndPos.Row < StartPos.Row) then Exit;
    if (EndPos.Row = StartPos.Row) and (EndPos.Col <= StartPos.Col) then Exit;

    //  JnƏIs̏ꍇ
    if (StartPos.Row = EndPos.Row) then
    begin
        Result := Copy(FLines[StartPos.Row], StartPos.Col, EndPos.Col - StartPos.Col);
    end
    //  JnƏIႤs̏ꍇ
    else
    begin
        FStrBuf.Clear();

        //  Jns
        Result := FLines[StartPos.Row];
        FStrBuf.Add(Copy(Result, StartPos.Col, Length(Result) + 1 - StartPos.Col));

        //  r̍s
        for i := StartPos.Row + 1 to EndPos.Row - 1 do
        begin
            FStrBuf.Add(FLines[i]);
        end;

        //  TStringListAnsiStringɕϊ
        Result := FStrBuf.Text;

        //  Is
        Result := Result + Copy(FLines[EndPos.Row], 1, EndPos.Col - 1);

        FStrBuf.Clear();
    end;
end;

//=============================================================================
//  AhDChD
//=============================================================================

//-----------------------------------------------------------------------------
//  AhDp̓o^
procedure TTextEditor.UndoPush(Command: TCommand);
begin
    //  AhDX^bNcmdǉ
    FUndoStack.Push(Command);

	//  KvȂ烊hDX^bNSđoC
    if FClearRedoStack then
    begin
        while FRedoStack.AtLeast(1) do FRedoStack.Pop.Free;
    end;
end;

//-----------------------------------------------------------------------------
//  AhD̎s
procedure TTextEditor.Undo(const Shift: TShiftState);
var
    Command: TCommand;
begin
    if (not FUndoStack.AtLeast(1)) then Exit;

    //  AhDX^bN瑀oCsB
    //  ̂ƂChDX^bNȂ悤ɂ
    Command := TCommand(FUndoStack.Pop());
    FClearRedoStack := False;
    Command.Execute(Self);
    FClearRedoStack := True;
    Command.Free;

    //  s̋t̑삪AhDX^bNɓ̂ŁC
    //  hDX^bNɈڂ
    FRedoStack.Push(FUndoStack.Pop());
end;

//-----------------------------------------------------------------------------
//  hD̎s
procedure TTextEditor.Redo(const Shift: TShiftState);
var
    Command: TCommand;
begin
    if (not FRedoStack.AtLeast(1)) then Exit;

    //  hDX^bN瑀oCsB
    //  ̂ƂChDX^bNȂ悤ɂB
    //  s̋t̑삪AhDobt@ɓ
    Command := TCommand(FRedoStack.Pop());
    FClearRedoStack := False;
    Command.Execute(Self);
    FClearRedoStack := True;
    Command.Free;
end;

//=============================================================================
//  擾
//=============================================================================

//-----------------------------------------------------------------------------
//  \sԂ
function TTextEditor.GetDispLineCount(): integer;
begin
    //Result := (FControl.ClientHeight - FTopMargin) div (FDBuffer.Canvas.TextHeight('Wg')) + 1;
    //Result := (FControl.ClientHeight) div (FDBuffer.Canvas.TextHeight('Wg')) + 1;
    Result := (FControl.ClientHeight) div (FDBuffer.Canvas.TextHeight('Wg') + FLineMargin * 2) + 1;
end;

//=============================================================================
//  `
//=============================================================================

//-----------------------------------------------------------------------------
//  Ŝ̕`
procedure TTextEditor.Paint(Canvas: TCanvas; var CursorX, CursorY: integer);
var
    ClientRect: TRect;
    ClientWidth: integer;
    ClientHeight: integer;
    h, i, x, y: integer;
    c: TCanvas;
    DispLines: integer;
    Line, ExLine: string;

    SelPos, SelLen: integer;

    R: TRect;
begin
    ClientRect   := FControl.ClientRect;
    ClientWidth  := FControl.ClientWidth;
    ClientHeight := FControl.ClientHeight;

	//  WtHg̏
    c := FDBuffer.Canvas;
    c.Font := Canvas.Font;
	//h := - c.Font.Height;
	h := c.TextHeight('Wg') + FLineMargin * 2;

    //  _uobt@̃TCY𒲐
    if (FDBuffer.Width < ClientWidth) then FDBuffer.Width := ClientWidth;
    if (FDBuffer.Height < h) then FDBuffer.Height := h;

    //  J[\ʓɔ[܂悤ɁC\Jnʒu𒲐
    if (FCursor.Row < FTopLine + FScrollMargin) then
    begin
        FTopLine := FCursor.Row - FScrollMargin;
    end;
    DispLines := GetDispLineCount();
    if (FCursor.Row + FScrollMargin >= FTopLine + DispLines) then
    begin
        FTopLine := FCursor.Row + FScrollMargin - DispLines + 1;
    end;
    if (FTopLine < 0) then FTopLine := 0;
    if (FTopLine >= FLines.Count) then FTopLine := FLines.Count - 1;

    //  eLXg̕\
    //i := 0;
    i := FTopLine;
    while (i < FLines.Count) and (i < FTopLine + DispLines) do
    begin
        //  1so
        Line := FLines[i];
        //  ^uWJ邵̂Ă
        ExLine := TabsToSpaces(Line);

        //  `ʒu
        x := 0;
        y := (i - FTopLine) * h;
        R := Rect(0, 0, ClientWidth, h);

        SelLen := 0;
        //  IJnʒuݍsO̍sŎn܂Ă
        if (FSelStart.Row < i) then
        begin
            //  擪IԂ
            SelPos := 1;
            //  ݍs̍sŏIĂ΁AԍŌ܂őI
            if (i < FSelEnd.Row) then SelLen := Length(ExLine)
            //  ̍sŏIĂ΁AII܂
            else if (i = FSelEnd.Row) then SelLen := FSelEnd.Col - 1;
        end
        //  IJnʒuݍsƓȂ
        else if (FSelStart.Row = i) then
        begin
            //  IJnʒu
            SelPos := FSelStart.Col;
            //  ݍs̍sŏIĂ΁AԍŌ܂őI
            if (i < FSelEnd.Row) then SelLen := Length(ExLine) + 1 - FSelStart.Col
            //  ̍sŏIĂ΁AII܂
            else if (i = FSelEnd.Row) then SelLen := FSelEnd.Col - FSelStart.Col;
        end
        //  IɊ֌WȂ
        else SelPos := 0;

        //  1s̃eLXg`悷

        //.....

        //  wihԂĂ
        c.Brush.Color := FBackColor;
        c.Font.Color := FFontColor;
        c.FillRect(R);

        //  ʓɎ܂Ă
        if (FTopLine <= i) then
        begin
            c.TextRect(R, x, FLineMargin, PChar(ExLine));
        end;

        //  ݍs̏ꍇ\
        if (i = FCursor.Row) then
        begin
            c.Pen.Color := FCurrentLineColor;
            c.MoveTo(0, h - 1);
            c.LineTo(ClientWidth, h - 1);
        end;

        //  I͈͂`悷iʏ̕`ɏ㏑j
        if (SelLen > 0) then
        begin
            c.Brush.Color := FSelBackColor;
            c.Font.Color := FSelFontColor;
            R.Left := c.TextWidth(TabsToSpaces(Copy(Line, 1, SelPos - 1)));
            R.Right := R.Left + c.TextWidth(TabsToSpaces(Copy(Line, SelPos, SelLen)));
            c.TextRect(R, R.Left, FLineMargin, TabsToSpaces(Copy(Line, SelPos, SelLen)));
        end;

        //  _uobt@ʂɃRs[i\j
        Canvas.Draw(0, y, FDBuffer);

        //  sԍi߂
        Inc(i);
    end;

    //  ʉ̗]
    y := (i - FTopLine) * h;
    if (y < ClientHeight) then
    begin
        Canvas.Brush.Color := FBackColor;
        Canvas.FillRect(Rect(0, y, ClientWidth, FControl.ClientHeight));
    end;

    //  J[\̕`
    //  J[\̍W͌Ăяoɖ߂(IMEϊEBhËʒuݒ̂߂Ɏg)
    x := Canvas.TextWidth(TabsToSpaces(Copy(FLines[FCursor.Row], 1, FCursor.Col - 1)));
    CursorX := x + 1;

    y := (FCursor.Row - FTopLine) * h;
    CursorY := y + (h - Canvas.TextHeight('Wg')) div 2 + 1;

    //  c
    Canvas.Pen.Color := FCurrentLineColor;
    Canvas.MoveTo(x, 0);
    Canvas.LineTo(x, ClientHeight);

    //  J[\
    Canvas.Pen.Color := FCursorColor;
    Canvas.MoveTo(x, y);
    Canvas.LineTo(x, y + h);
end;

(*
//==============================================
// RXgN^
TTextEditor::TTextEditor(TControl* control, AnsiString ini_file)
: Control(control)
{

	// ȍ
	Highlights=new TList();
	HighlightsMulti=new TList();
	BasicFont=new TFont();
	BasicAttribute=new TAttribute(clBlack, clWhite);

	// I͈͂Ɋւ鏉
	SelAttribute=new TAttribute(clWhite, clBlack);

	// ݒt@C̓ǂݍ
	LoadIniFile(ini_file);

}


//==============================================
// `

// ʑŜ̕`
void TTextEditor::Paint(TCanvas* canvas, int* cursorX, int* cursorY) {
	int i, j, x, y, w, h;
	int p, l, r, pos, len, ofs, ret;
	int sel_pos, sel_len, sel_x;
	THighlight *hl, *match_hl, *multi_hl;
	TAttribute* attr;
	AnsiString s, t;
	int disp_lines;


	// eLXg̕\
	multi_hl=NULL;
	for (i=0; i<Lines->Count && i<TopLine+disp_lines; i++) {
		s=Lines->Strings[i];
		x=0;
		y=(i-TopLine)*h;

...
		// 1s̃eLXg\
		for (ofs=1; ofs<=s.Length(); ofs=pos+len) {

			// sp^[łȂꍇiʏԁj
			if (multi_hl==NULL) {

				// ԍɂ鋭\p^[T
				pos=s.Length()+1;
				match_hl=NULL;
				ret=0;

				// ̍sʓ̏ꍇɂ́C
				// SẴp^[
				if (TopLine<=i) {
					for (j=0; j<Highlights->Count; j++) {
						hl=(THighlight* )Highlights->Items[j];
						if ((r=hl->Match(s, ofs, &p, &l))>0) {
							if (p>0 && p<pos) {
								pos=p; len=l; ret=r;
								match_hl=hl;
							}
						}
					}
				} else
				
				// ̍sʊȌꍇɂ́C
				// sp^[sɓnꍇ݂̂
				{
					for (j=0; j<HighlightsMulti->Count; j++) {
						hl=(THighlight* )HighlightsMulti->Items[j];
						if ((r=hl->MatchMulti(s, ofs, &p, &l))==2) {
							if (p>0 && p<pos) {
								pos=p; len=l; ret=r;
								match_hl=hl;
							}
						}
					}
				}

				// \p^[ȂƂɂ́C
				// c̃eLXgŜ\
				if (match_hl==NULL) {
					pos=ofs; len=s.Length()-ofs+1;
					attr=BasicAttribute;
				} else
				
				// \p^[Ƃɂ́C
				// ̃p^[̕\ŕ\
				// ߂l2̏ꍇɂ́Csp^[̏s
				{
					attr=match_hl->GetAttr();
					if (ret==2) {
						multi_hl=match_hl;
					}
				}

			} else
			
			// sp^[̏ꍇ
			{

				// sp^[̖C
				// ʏԂɈڍs
				if (multi_hl->MultiEnd(s, &p, &l)) {
					pos=1; len=p+l-1;
					multi_hl=NULL;
				} else
				
				// Ȃ΁C
				// sp^[̏p
				{
					pos=1; len=s.Length();
				}

			}

			// ̕\͉ʓɂĂs
			if (TopLine<=i) {

				// \p^[̑O܂ł\
				if (pos>ofs) {
					t=TabsToSpaces(s.SubString(ofs,pos-ofs));
					w=c->TextWidth(t);

					// iwi܂ށj`
					// ŜI͈͂Ɋ܂܂Ă`Ȃ
					if (ofs<sel_pos || sel_pos+sel_len<pos) {
						c->Brush->Color=BasicAttribute->BackColor;
						c->Font->Color=BasicAttribute->FontColor;
						c->TextOut(x,0,t);
					}

					x+=w;
				}

				// \p^[̕\
				if (len>0) {
					t=TabsToSpaces(s.SubString(pos,len));
					w=c->TextWidth(t);

					// iwi܂ށj`
					// ŜI͈͂Ɋ܂܂Ă`Ȃ
					if (pos<sel_pos || sel_pos+sel_len<pos+len) {
						c->Brush->Color=attr->BackColor;
						c->Font->Color=attr->FontColor;
						c->TextOut(x,0,t);
					}

					x+=w;
				}
			}
		}
	}
}

//==============================================
// ݒt@Cǂݍ

// t@C̓ǂݍ
void TTextEditor::LoadIniFile(AnsiString file_name) {
	TStringList* sl=new TStringList();
	TStringList* tk=new TStringList();
	AnsiString s;

	// t@Cǂݍ
	if (!FileExists(file_name)) return;
	sl->LoadFromFile(file_name);

	// \p^[t@C̓ǂݍ
	s="highlight.ini";
	tk->CommaText=sl->Values["Highlight"];
	if (tk->Count>=1) s=tk->Strings[0];
	LoadHighlightFile(s);

	// L[zuݒt@C̓ǂݍ
	s="keybind.ini";
	tk->CommaText=sl->Values["KeyBind"];
	if (tk->Count>=1) s=tk->Strings[0];
	LoadKeyBindFile(s);

	// {tHg̐ݒ
	tk->CommaText=sl->Values["BasicFont"];
	if (tk->Count>=2) {
		BasicFont->Name=tk->Strings[0];
		BasicFont->Size=tk->Strings[1].ToInt();
	}

	// ^u̕
	SpacesForTab=4;
	s=sl->Values["SpacesForTab"];
	if (s!="") SpacesForTab=s.ToInt();

	// XN[̃}[Ws
	ScrollMargin=5;
	s=sl->Values["ScrollMargin"];
	if (s!="") ScrollMargin=s.ToInt();

	// P\镶̃Zbg
	s="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_";
	tk->CommaText=sl->Values["WordLetters"];
	if (tk->Count>=1) s=tk->Strings[0];
	WordLetters=s;

	delete sl;
	delete tk;
}

// \p^[t@C̓ǂݍ
void TTextEditor::LoadHighlightFile(AnsiString file_name) {
	TAttribute* attr;
	TStringList* sl=new TStringList();
	TStringList* tokens=new TStringList();
	AnsiString s, from, to, u;
	int i, r, g, b;
	int fc, bc;
	HLType type=HL_BASIC;
	THighlight* hl;

	// t@CJ
	if (!FileExists(file_name)) return;
	sl->LoadFromFile(file_name);

	// \p^[
	Highlights->Clear();
	
	for (i=0; i<sl->Count; i++) {
		s=sl->Strings[i];
		if (s.Length()==0) continue;
		
		// #n܂si`j̏
		if (s.Pos("#")==1) {

			// ʂǂ
			u=s.UpperCase();
			if (u.Pos("#BASIC")==1) type=HL_BASIC; else
			if (u.Pos("#SELECT")==1) type=HL_SELECT; else
			if (u.Pos("#SINGLE")==1) type=HL_SINGLE; else
			if (u.Pos("#WORD")==1) type=HL_WORD; else
			if (u.Pos("#EWORD")==1) type=HL_EWORD; else
			if (u.Pos("#MULTI")==1) type=HL_MULTI;
			
			// Fǂ
			// tHgFwiFݒ̏ꍇɂ́C
			// ftHg̐Fg
			tokens->CommaText=s;
			fc=BasicAttribute->FontColor;
			bc=BasicAttribute->BackColor;
			
			// tHgF̓ǂݍ
			if (tokens->Count>3) {
				r=tokens->Strings[1].ToInt();
				g=tokens->Strings[2].ToInt();
				b=tokens->Strings[3].ToInt();
				fc=((b&255)<<8|(g&255))<<8|(r&255);

				// wiF̓ǂݍ
				if (tokens->Count>6) {
					r=tokens->Strings[4].ToInt();
					g=tokens->Strings[5].ToInt();
					b=tokens->Strings[6].ToInt();
					bc=((b&255)<<8|(g&255))<<8|(r&255);
				}

			}

			// ݒ肷
			attr=new TAttribute((TColor)fc, (TColor)bc);
			
			// u#BASICvs̏
			if (type==HL_BASIC) BasicAttribute=attr; else
			if (type==HL_SELECT) SelAttribute=attr;

		} else

		// #n܂Ȃsip^[`j̏
		{
			if (type!=HL_BASIC && type!=HL_SELECT) {
				tokens->CommaText=s;

				// Jnp^[(From)̓ǂݍ
				// ǂݍ߂Ȃꍇ̓p^[o^Ȃ
				if (tokens->Count>=1) {
					from=tokens->Strings[0];

					// Ip^[iToj̓ǂݍ
					// ǂݍ߂Ȃꍇ""ݒ
					if (tokens->Count>=2) {
						to=tokens->Strings[1];
					} else {
						to="";
					}

					// p^[̓o^
					hl=new THighlight(
						type, from, to, attr, WordLetters);
					Highlights->Add(hl);
					if (type==HL_MULTI) HighlightsMulti->Add(hl);

				}
			}
		}
	}
}

*)

//=============================================================================
//  initialization / finalization
//=============================================================================

initialization
    //
finalization
    //
end.

